<?php

if (!defined('SMF'))
	die('No direct access...');

function old_attach_bbc(&$codes, &$no_autolink_tags)
{
	/**
	 * Copyright © 2011 Simple Machines. All rights reserved.
	 *
	 * Developed by: Simple Machines Forum Project
	 * Simple Machines
	 * http://www.simplemachines.org
	 *
	 * All rights reserved.
	 *
	 * Redistribution and use in source and binary forms, with or without
	 * modification, are permitted provided that the following conditions are met:
	 *
	 * * Redistributions of source code must retain the above copyright notice, this
	 *   list of conditions and the following disclaimer.
	 *
	 * * Redistributions in binary form must reproduce the above copyright notice,
	 *   this list of conditions and the following disclaimer in the documentation
	 *   and/or other materials provided with the distribution.
	 *
	 * * Neither the name of SMF2.1 nor the names of its
	 *   contributors may be used to endorse or promote products derived from
	 *   this software without specific prior written permission.
	 *
	 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
	 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
	 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
	 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
	 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
	 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
	 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
	 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
	 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
	 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
	 */

	global $modSettings, $context, $sourcedir, $txt;

	// Deprecated version from SMF 2.1 betas
	$codes[] = array(
		'tag' => 'attach',
		'type' => 'unparsed_content',
		'parameters' => array(
			'name' => array('optional' => true),
			'type' => array('optional' => true),
			'alt' => array('optional' => true),
			'title' => array('optional' => true),
			'width' => array('optional' => true, 'match' => '(\d+)'),
			'height' => array('optional' => true, 'match' => '(\d+)'),
		),
		'content' => '$1',
		'validate' => function (&$tag, &$data, $disabled, $params) use ($modSettings, $context, $sourcedir, $txt)
		{
			$returnContext = '';

			// BBC or the entire attachments feature is disabled
			if (empty($modSettings['attachmentEnable']) || !empty($disabled['attach']))
				return $data;

			// Save the attach ID.
			$attachID = $data;

			// Kinda need this.
			require_once($sourcedir . '/Subs-Attachments.php');

			$currentAttachment = parseAttachBBC($attachID);

			// parseAttachBBC will return a string ($txt key) rather than dying with a fatal_error. Up to you to decide what to do.
			if (is_string($currentAttachment))
				return $data = !empty($txt[$currentAttachment]) ? $txt[$currentAttachment] : $currentAttachment;

			if (!empty($currentAttachment['is_image']))
			{
				$alt = ' alt="' . (!empty($params['{alt}']) ? $params['{alt}'] : $currentAttachment['name']) . '"';
				$title = !empty($params['{title}']) ? ' title="' . $params['{title}'] . '"' : '';

				$width = !empty($params['{width}']) ? ' width="' . $params['{width}'] . '"' : '';
				$height = !empty($params['{height}']) ? ' height="' . $params['{height}'] . '"' : '';

				if (empty($width) && empty($height))
				{
					$width = ' width="' . $currentAttachment['width'] . '"';
					$height = ' height="' . $currentAttachment['height'] . '"';
				}

				if ($currentAttachment['thumbnail']['has_thumb'] && empty($params['{width}']) && empty($params['{height}']))
					$returnContext .= '<a href="'. $currentAttachment['href']. ';image" id="link_'. $currentAttachment['id']. '" onclick="'. $currentAttachment['thumbnail']['javascript']. '"><img src="'. $currentAttachment['thumbnail']['href']. '"' . $alt . $title . ' id="thumb_'. $currentAttachment['id']. '" class="atc_img"></a>';
				else
					$returnContext .= '<img src="' . $currentAttachment['href'] . ';image"' . $alt . $title . $width . $height . ' class="bbc_img"/>';
			}

			// No image. Show a link.
			else
				$returnContext .= $currentAttachment['link'];

			// Gotta append what we just did.
			$data = $returnContext;
		},
	);
}